"use strict";
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    Object.defineProperty(o, k2, { enumerable: true, get: function() { return m[k]; } });
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __setModuleDefault = (this && this.__setModuleDefault) || (Object.create ? (function(o, v) {
    Object.defineProperty(o, "default", { enumerable: true, value: v });
}) : function(o, v) {
    o["default"] = v;
});
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (k !== "default" && Object.prototype.hasOwnProperty.call(mod, k)) __createBinding(result, mod, k);
    __setModuleDefault(result, mod);
    return result;
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.ResourcePack = void 0;
const bc_minecraft_bedrock_project_1 = require("bc-minecraft-bedrock-project");
const Animation = __importStar(require("./Animation/entry"));
const AnimationController = __importStar(require("./Animation Controllers/entry"));
const Attachable = __importStar(require("./Attachable/entry"));
const BiomesClient = __importStar(require("./Biomes Client/entry"));
const Block = __importStar(require("./Block/entry"));
const Entity = __importStar(require("./Entity/entry"));
const Fog = __importStar(require("./Fog/entry"));
const Item = __importStar(require("./Item/entry"));
const Manifest = __importStar(require("./Manifest/entry"));
const Material = __importStar(require("./Material/entry"));
const Model = __importStar(require("./Model/entry"));
const MusicDefinitions = __importStar(require("./Music Definitions/entry"));
const Particle = __importStar(require("./Particle/entry"));
const RenderController = __importStar(require("./Render Controller/entry"));
const Sounds = __importStar(require("./Sounds/entry"));
const SoundsDefinitions = __importStar(require("./Sounds Definitions/entry"));
const Texture = __importStar(require("./Texture/entry"));
const TextureAtlas = __importStar(require("./Texture Atlas/entry"));
var ResourcePack;
(function (ResourcePack) {
    function Process(doc, diagnoser) {
        const Type = bc_minecraft_bedrock_project_1.ResourcePack.FileType.detect(doc.uri);
        switch (Type) {
            case bc_minecraft_bedrock_project_1.ResourcePack.FileType.animation:
                Animation.Diagnose(doc, diagnoser);
                break;
            case bc_minecraft_bedrock_project_1.ResourcePack.FileType.animation_controller:
                AnimationController.Diagnose(doc, diagnoser);
                break;
            case bc_minecraft_bedrock_project_1.ResourcePack.FileType.attachable:
                Attachable.Diagnose(doc, diagnoser);
                break;
            case bc_minecraft_bedrock_project_1.ResourcePack.FileType.biomes_client:
                BiomesClient.Diagnose(doc, diagnoser);
                break;
            case bc_minecraft_bedrock_project_1.ResourcePack.FileType.block:
                Block.Diagnose(doc, diagnoser);
                break;
            case bc_minecraft_bedrock_project_1.ResourcePack.FileType.entity:
                Entity.Diagnose(doc, diagnoser);
                break;
            case bc_minecraft_bedrock_project_1.ResourcePack.FileType.fog:
                Fog.Diagnose(doc, diagnoser);
                break;
            case bc_minecraft_bedrock_project_1.ResourcePack.FileType.item:
                Item.Diagnose(doc, diagnoser);
                break;
            case bc_minecraft_bedrock_project_1.ResourcePack.FileType.manifest:
                Manifest.Diagnose(doc, diagnoser);
                break;
            case bc_minecraft_bedrock_project_1.ResourcePack.FileType.material:
                Material.Diagnose(doc, diagnoser);
                break;
            case bc_minecraft_bedrock_project_1.ResourcePack.FileType.model:
                Model.Diagnose(doc, diagnoser);
                break;
            case bc_minecraft_bedrock_project_1.ResourcePack.FileType.music_definitions:
                MusicDefinitions.Diagnose(doc, diagnoser);
                break;
            case bc_minecraft_bedrock_project_1.ResourcePack.FileType.particle:
                Particle.Diagnose(doc, diagnoser);
                break;
            case bc_minecraft_bedrock_project_1.ResourcePack.FileType.render_controller:
                RenderController.Diagnose(doc, diagnoser);
                break;
            case bc_minecraft_bedrock_project_1.ResourcePack.FileType.sounds:
                Sounds.Diagnose(doc, diagnoser);
                break;
            case bc_minecraft_bedrock_project_1.ResourcePack.FileType.sounds_definitions:
                SoundsDefinitions.Diagnose(doc, diagnoser);
                break;
            case bc_minecraft_bedrock_project_1.ResourcePack.FileType.texture:
                Texture.Diagnose(doc, diagnoser);
                break;
            case bc_minecraft_bedrock_project_1.ResourcePack.FileType.texture_flipbook_atlas:
                TextureAtlas.DiagnoseFlipbook(doc, diagnoser);
                break;
            case bc_minecraft_bedrock_project_1.ResourcePack.FileType.texture_item_atlas:
            case bc_minecraft_bedrock_project_1.ResourcePack.FileType.texture_terrain_atlas:
                TextureAtlas.DiagnoseAtlas(doc, diagnoser);
                break;
            default:
            case bc_minecraft_bedrock_project_1.ResourcePack.FileType.unknown:
                return false;
        }
        return true;
    }
    ResourcePack.Process = Process;
})(ResourcePack = exports.ResourcePack || (exports.ResourcePack = {}));
//# sourceMappingURL=ResourcePack.js.map